function filterFunction() {
  var filter_a, filter_t, filter_s, filter_g, tr, td_a, td_t, i;
  var td_s, td_g, filter_r, td_r, filter_c, td_c;
  filter_a = document.getElementById('input_Authors').value.toUpperCase();
  filter_t = document.getElementById('input_Title').value.toUpperCase();
  filter_s = document.getElementById('input_Institute').value.toUpperCase();
  filter_c = document.getElementById('input_Country').value.toUpperCase();
  filter_g = document.getElementById('input_Session').value.toUpperCase();
  filter_r = document.getElementById('input_Room').value.toUpperCase();
  tr       = document.getElementById('dataTable').getElementsByTagName('tr');
  if (filter_g == 'ALL') filter_g = '';
  if (filter_r == 'ALL') filter_r = '';
  if (filter_c == 'ALL') filter_c = '';
  for (i = 0; i < tr.length; i++) {
    td_a = tr[i].getElementsByTagName('td')[1];
    td_t = tr[i].getElementsByTagName('td')[2];
	td_s = tr[i].getElementsByTagName('td')[3];
	td_c = tr[i].getElementsByTagName('td')[4];
	td_g = tr[i].getElementsByTagName('td')[5];
	td_r = tr[i].getElementsByTagName('td')[6];
    if (td_a && td_t && td_s && td_c && td_g && td_r) {
		var show = false;
		var instance = new Mark(tr[i]);
		instance.unmark();
		// Filter by authors, title, topic and country
		if (td_a.innerHTML.toUpperCase().indexOf(filter_a) > -1 &&
			td_t.innerHTML.toUpperCase().indexOf(filter_t) > -1 &&
			td_s.innerHTML.toUpperCase().indexOf(filter_s) > -1 &&
			td_c.innerHTML.toUpperCase().indexOf(filter_c) > -1 &&
			td_g.textContent.toUpperCase().indexOf(filter_g) > -1 &&
			td_r.innerHTML.toUpperCase().indexOf(filter_r) > -1) {
			tr[i].style.display = '';
			if (filter_a.length >= 3) instance.mark(filter_a);
			if (filter_t.length >= 3) instance.mark(filter_t, {"separateWordSearch": false});
			if (filter_s.length >= 3) instance.mark(filter_s, {"separateWordSearch": false});
			if (filter_c.length >= 3) instance.mark(filter_c, {"separateWordSearch": false});
			if (filter_g.length >= 3) instance.mark(filter_g, {"separateWordSearch": false});
			if (filter_r.length >= 3) instance.mark(filter_r, {"separateWordSearch": false});
		} else {
			tr[i].style.display = 'none';
			instance.unmark();
		}
    }       
  }
}

function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}

async function sortTable(idx) {
  var table, rows, switching, i, x, y, shouldSwitch, header;
  table = document.getElementById("dataTable");
  header = table.getElementsByTagName('tr')[0].getElementsByTagName('th');
  var ascending = true;
  for (i = 0; i<header.length; i++) {
	  if (i==idx) { 
	    if (header[i].classList.contains('ascending')) {
			ascending = false;
		} else {
			ascending = true;
		}
	  }
	  header[i].classList.remove('ascending');
      header[i].classList.remove('descending');	 
  }
  header[idx].classList.add('sorting');
  header[idx].style.display='none';
  header[idx].offsetHeight;
  header[idx].style.display='table-cell';
  //console.log("Sorting table by "+idx+", "+(ascending?"ascending":"descending"));
  await sleep(20);
  switching = true;
  while (switching) {
    switching = false;
    rows = table.getElementsByTagName('tr');
    for (i = 1; i < (rows.length - 1); i++) {
      shouldSwitch = false;
      x = rows[i].getElementsByTagName('td')[idx];
      y = rows[i + 1].getElementsByTagName('td')[idx];
	  if (ascending) {
		  if (x.innerHTML.toLowerCase() > y.innerHTML.toLowerCase()) { shouldSwitch = true; break; } 
	  } else {
		  // Descending
		  if (x.innerHTML.toLowerCase() < y.innerHTML.toLowerCase()) { shouldSwitch = true; break; }
	  }
    }
    if (shouldSwitch) {
	  rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
      switching = true;
    }
  }
  header[idx].classList.remove('sorting');
  if (ascending) {
	header[idx].classList.add('ascending');
  } else {
	header[idx].classList.add('descending');  
  }
  //console.log("Done.");
}